#!/usr/bin/python

import sys
import math
sys.path.append('./')
import tr_obj
import HMM_IO
import algo_HMM
import string
import re

softProb= lambda x: 1.0/(1+math.exp(1-2*x))

def filterSS(ss):
    ''' '''
    pat=re.compile('H+')
    TH=7
    groupSS=pat.search(ss)
    while groupSS:
         b,e=groupSS.span()
         lseg = e-b
         if lseg < TH:
           ss=ss[:b]+'C'*lseg+ss[e:]
         groupSS=pat.search(ss,e)
    return ss


def predmod(hmm,seq):
    
    (bestpath,bestVal,posprob)=algo_HMM.maxAcc_decoder(hmm,seq,True)
    ss=''.join(filterSS( ''.join(bestpath) ))
    (m,bestpath,lp)=algo_HMM.sum_aposteriori(hmm,seq,Scale='yes',label_list=hmm.label_list)
    score=0.0
    num=0
    plen=len(seq)
    cclab=hmm.label_list.index('H')
    for i in range(plen):
        if (bestpath[i] == 'H') : # coiled coils
            score+=m[i][cclab]
    s=score/plen-1
    prob=math.exp(-8.0*s*s)
    return ss,prob,[softProb(x) for x in posprob]

